redshift_quries:
    q_siteid: select count(*) from public.contracted_dispenser_site where site_id =:siteid
    
    q_siteid_details: select brand,address_line_1,city,phone,site_name from public.contracted_dispenser_site where site_id =:siteid
      
    q_site_search:
        SELECT DISTINCT dcs.site_id,
               dcs.dispenser_device_id,
               d.dispenser_type_code,
               d.dispenser_position,
               sd.device_type_code,
               dcs.fueling_position,
               fp.fueling_position_type,
               component,
               status
        FROM dispenser_current_status dcs
          JOIN dispenser d ON d.dispenser_device_id = dcs.dispenser_device_id
          JOIN fueling_postion fp ON fp.device_id = dcs.device_id
          JOIN site_device sd ON sd.device_id = dcs.device_id
        WHERE status IN ('in-error','down','in-warning')
        
        AND   dcs.site_id = :site_id
        ORDER BY dcs.dispenser_device_id,
                 dcs.device_id,
                 dcs.fueling_position
   
   
    q_site_search1:
          SELECT distinct  dcs.site_id,
                   dcs.dispenser_device_id,
                   d.dispenser_type_code,
                   d.dispenser_position,
                   sd.device_type_code,
                   dcs.fueling_position,
                   fp.fueling_position_type,
                   component,dcs.cause,
                   status
            FROM dispenser_current_status dcs
              JOIN dispenser d ON d.dispenser_device_id = dcs.dispenser_device_id
              JOIN fueling_postion fp ON fp.device_id = dcs.device_id
              JOIN site_device sd ON sd.device_id = dcs.device_id
            WHERE component ='overall-system'
            AND d.dispenser_position=:dispenser_position  AND dcs.fueling_position =:fueling_position
            AND   dcs.site_id = :site_id
            ORDER BY dcs.dispenser_device_id,
                     dcs.device_id,
                     dcs.fueling_position
   
    q_site_similar: select  site_id, site_name, brand,address_line_1, phone from public.contracted_dispenser_site where site_id like :siteid order by site_id

    q_city: select site_id,site_name,brand from public.contracted_dispenser_site where UPPER(city) =UPPER(:city)
    
    q_city_street_search: select site_id,site_name,brand from public.contracted_dispenser_site where UPPER(city) = UPPER(:city) and UPPER(address_line_1) = UPPER(:address_line)

    q_device_id: select device_id,device_type_code from public.site_device  where site_id = :siteid and device_type_code in ('M7','M5')

    q_city_search: select site_id,site_name,brand, address_line_1 from public.contracted_dispenser_site where UPPER(city) = UPPER(:city )

    q_dispenser_l2_opt1: select distinct device_id,fueling_position, kpi, state, dt from public.dispenser_kpi where site_id =:siteid and device_id = :deviceid and data_source in ('M7-kpi-event','M5-kpi-event','PCN-kpi-event') and category in ('Operation Warning','Operation Error','System Error','System Warning') and dt = to_char(sysdate, 'YYYY-MM-DD')
    
    q_dispenser_l2_opt2: select distinct device_id,fueling_position, kpi, state, dt from public.dispenser_kpi where site_id =:siteid and device_id in (select device_id from public.fueling_postion where dispenser_device_id = :dispenserDeviceId) and data_source in ('M7-kpi-event','M5-kpi-event','PCN-kpi-event') and category in ('Operation Warning','Operation Error','System Error','System Warning') and dt = to_char(sysdate, 'YYYY-MM-DD')

    q_dispenser_l2_opt3: select distinct dispenser_device_id from public.dispenser where dispenser_position = :dispenserPosition and site_id = :siteid;

    q_dispenser_l2_opt33: select distinct device_id,fueling_position, kpi, state, dt from public.dispenser_kpi where site_id =:siteid and device_id in (select device_id from public.fueling_postion where dispenser_device_id = :dispenserDeviceId) and data_source in ('M7-kpi-event','M5-kpi-event','PCN-kpi-event') and category in ('Operation Warning','Operation Error','System Error','System Warning') and dt = to_char(sysdate, 'YYYY-MM-DD')
    
    q_dispenser_l3:  select distinct device_id, fueling_position, component,status,error,state,state_ext, cause,dt  from public.dispenser_status where device_id = :deviceid and dt = to_char(sysdate, 'YYYY-MM-DD') and  component != 'overall-system' and status in ('in-warning','in-error','down')
    
   # q_site_search_by: select brand,address_line_1,city,phone,site_name from public.contracted_dispenser_site where UPPER(city)= NVL(UPPER(:city),UPPER(city)) and UPPER(address_line_1) = NVL(UPPER(:address_line_1),UPPER(address_line_1)) and postal_code = NVL(:postal_code,postal_code) and phone = NVL(:phone,phone) 
 
    #q_site_search_by: select s.site_id, s.site_name, s.brand, s.address_line_1, s.city, s.state, s.postal_code, s.phone, s.latitude, s.longitude, count(DISTINCT dispenser_device_id)  as issues from contracted_dispenser_site s left outer join dispenser_current_status dcs ON dcs.site_id = s.site_id and dcs.status in ('in-warning', 'in-error', 'down') where lower(s.city) like NVL( lower(:city),lower(s.city)) and lower(s.address_line_1) like NVL( lower(:address_line_1),lower(s.address_line_1)) group by s.site_id, s.site_name, s.brand, s.address_line_1, s.city, s.state, s.postal_code, s.phone, s.latitude, s.longitude order by s.site_name, s.brand 


    
# q_dispenser_l_l2: select error, state, state_ext from public.dispenser_status where site_id =:siteid and device_id in  (:devicelist) and dt = sysdate and data_source in ('M7-component-status-event','M5-component_status-event')

   # q_dispenser_issue: select dt, transaction_hr as hour , incidents from public.dispenser_kpi_hourly where site_id =:siteid and device_id = :deviceid and kpi = :kpi and state =:state

   # q_incidents_details: select dt,total_incidents,avg_hourly_incidents,min_hourly_incidents,max_hourly_incidents,std_hourly_incident from public.dispenser_kpi_daily where site_id = :siteid and device_id = :deviceid and kpi = :kpi and state =:state

    q_street: select site_id,site_name,brand, city, address_line_1 from public.site where UPPER(address_line_1) = UPPER(:street_name )
    
    q_site_search_by1:
            SELECT s.site_id,
                   s.site_name,
                   s.brand,
                   s.address_line_1,
                   s.city,
                   s.state,
                   s.postal_code,
                   s.phone,
                   s.latitude,
                   s.longitude,
                   COUNT(DISTINCT dispenser_device_id) AS issues
            FROM contracted_dispenser_site s
              LEFT OUTER JOIN dispenser_current_status dcs
                           ON dcs.site_id = s.site_id
                          AND dcs.status IN ('in-warning', 'in-error', 'down') 
            WHERE 
    q_site_search_by2:
           
             GROUP BY s.site_id,
                     s.site_name,
                     s.brand,
                     s.address_line_1,
                     s.city,
                     s.state,
                     s.postal_code,
                     s.phone,
                     s.latitude,
                     s.longitude
            ORDER BY s.site_name,
                     s.brand    
            
    
    q_site_search_by_city_state1:
           SELECT s.site_id,
           s.site_name,
           s.brand,
           s.address_line_1,
           s.city,
           s.state,
           s.postal_code,
           s.phone,
           s.latitude,
           s.longitude,
           COUNT(DISTINCT dispenser_device_id) AS issues
        FROM contracted_dispenser_site s
              LEFT OUTER JOIN dispenser_current_status dcs
                   ON dcs.site_id = s.site_id
                  AND dcs.status IN ('in-warning', 'in-error', 'down') 
                WHERE
    q_site_search_by_city_state2:

            GROUP BY s.site_id,
             s.site_name,
             s.brand,
             s.address_line_1,
             s.city,
             s.state,
             s.postal_code,
             s.phone,
             s.latitude,
             s.longitude
            ORDER BY s.site_name,
             s.brand
   #       AND   d.dt = TO_CHAR(sysdate,'YYYY-MM-DD')  
    q_search_by_fueling_position:
        
        SELECT d.site_id,
               d.dispenser_device_id,
               d.fueling_position,
               d.category,
               d.kpi,
               d.state,
               d.incidents
        FROM current_dispenser_kpi_issues d
        WHERE d.site_id = :site_id
        AND   d.fueling_position =:fueling_position
        ORDER BY d.site_id,
                 d.fueling_position,
                 d.category,
                 d.kpi,
                 d.state;

    q_search_by_disp_device_id:

        SELECT DISTINCT disp.dispenser_device_id
        FROM dispenser disp
        WHERE disp.site_id = :site_id
        AND   disp.dispenser_position = :dispenser_position
        
    q_search_by_disp_number:

         SELECT d.site_id,
               d.dispenser_device_id,
               d.fueling_position,
               d.category,
               d.kpi,
               d.state,
               d.incidents
        FROM current_dispenser_kpi_issues d
        WHERE d.site_id = :site_id
        AND   d.dispenser_device_id = :dispenser_device_id 
        ORDER BY d.site_id,
                 d.fueling_position,
                 d.category,
                 d.kpi,
                 d.state

    q_fueling_pos_validation:

        select count(*) from fueling_postion where site_id= :site_id and fueling_position =:fueling_position

    q_dispenser_pos_validation:

        select count(*) from dispenser where site_id = :site_id and dispenser_position = :dispenser_position

#AND   AND   d.dt = TO_CHAR(sysdate,'YYYY-MM-DD')
    q_fueling_pos_offline:
        
        SELECT d.site_id,
               d.dispenser_device_id,
               d.fueling_position,
               d.category,
               d.kpi,
               d.state,
               d.incidents
        FROM current_dispenser_kpi_issues d
        WHERE d.kpi IN ('offline','extended-offline')
        AND   d.site_id = :site_id
        ORDER BY d.site_id,
                 d.fueling_position,
                 d.category,
                 d.kpi,
                 d.state;